<?php
$plugins=array(
'email'=>array('aol'=>array('name'=>"AOL",
'version'=>"1.5.1",
'description'=>"Get the contacts from an AOL account",
'base_version'=>"1.8.0",
'type'=>"email",
'check_url'=>"http://webmail.aol.com",
'requirement'=>"email",
'allowed_domains'=>array('0'=>"/(aol.com)/i")),
'gmail'=>array('name'=>"GMail",
'version'=>"1.4.8",
'description'=>"Get the contacts from a GMail account",
'base_version'=>"1.6.3",
'type'=>"email",
'check_url'=>"http://google.com",
'requirement'=>"email",
'allowed_domains'=>false,
'detected_domains'=>array('0'=>"/(gmail.com)/i",
'1'=>"/(googlemail.com)/i"),
'imported_details'=>array('0'=>"first_name",
'1'=>"email_1",
'2'=>"email_2",
'3'=>"email_3",
'4'=>"organization",
'5'=>"phone_mobile",
'6'=>"phone_home",
'7'=>"fax",
'8'=>"pager",
'9'=>"address_home",
'10'=>"address_work")),
'hotmail'=>array('name'=>"Live/Hotmail",
'version'=>"1.6.3",
'description'=>"Get the contacts from a Windows Live/Hotmail account",
'base_version'=>"1.6.3",
'type'=>"email",
'check_url'=>"http://login.live.com/login.srf?id=2",
'requirement'=>"email",
'allowed_domains'=>array('0'=>"/(hotmail)/i",
'1'=>"/(live)/i",
'2'=>"/(msn)/i",
'3'=>"/(chaishop)/i"),
'imported_details'=>array('0'=>"first_name",
'1'=>"email_1")),
'linkedin'=>array('name'=>"LinkedIn",
'version'=>"1.1.2",
'description'=>"Get the contacts from a LinkedIn account",
'base_version'=>"1.8.0",
'type'=>"email",
'check_url'=>"http://www.linkedin.com",
'requirement'=>"email",
'allowed_domains'=>false),
'msn'=>array('name'=>"MSN",
'version'=>"1.0.1",
'description'=>"Get the contacts from a MSN People",
'base_version'=>"1.8.1",
'type'=>"email",
'check_url'=>"http://home.mobile.live.com/",
'requirement'=>"email",
'allowed_domains'=>false,
'imported_details'=>array('0'=>"first_name",
'1'=>"email_1")),
'yahoo'=>array('name'=>"Yahoo!",
'version'=>"1.5.4",
'description'=>"Get the contacts from a Yahoo! account",
'base_version'=>"1.8.0",
'type'=>"email",
'check_url'=>"http://mail.yahoo.com",
'requirement'=>"email",
'allowed_domains'=>array('0'=>"/(yahoo)/i",
'1'=>"/(ymail)/i",
'2'=>"/(rocketmail)/i"),
'imported_details'=>array('0'=>"first_name",
'1'=>"email_1"))),
'social'=>array('facebook'=>array('name'=>"Facebook",
'version'=>"1.2.7",
'description'=>"Get the contacts from a Facebook account",
'base_version'=>"1.8.0",
'type'=>"social",
'check_url'=>"http://apps.facebook.com/causes/",
'requirement'=>"email",
'allowed_domains'=>false),
'twitter'=>array('name'=>"Twitter",
'version'=>"1.1.1",
'description'=>"Get the contacts from a Twitter account",
'base_version'=>"1.8.0",
'type'=>"social",
'check_url'=>"http://twitter.com",
'requirement'=>"user",
'allowed_domains'=>false))
);
?>