<?php defined('SYSPATH') OR die('No direct access allowed.'); 

	class Search_Controller extends Website_Controller
	{
		public $template = 'template/template';

		 public function __construct()
		 {
			parent::__construct();
			$this->module = "search";
			//Nauth::module_login($this->module);
			$this->model = new Search_Model();
			$mes=Kohana::config('users_config.session_message');
			$this->login=$mes["login"];
			$this->best_answer=$mes["best_answer"];
			$this->select_answer=$mes["select_answer"];
			$this->question_delete=$mes["question_delete"];
			$this->answer_delete=$mes["answer_delete"];
			$this->page_notfound= $mes["notfound"];

			$this->get_tags = $this->model->get_tags();
		 }

		//Answer home page.
		public function search1($mod='',$key='')
		{
                       
                        $this->mod = $mod;
                        $this->key = $key;
			
			$page_no = $this->uri->last_segment();
			if($page_no == 0 || $page_no == "index")
			$page_no = 1;
			$offset = 10*($page_no-1);
			
	                if($mod=="codes")
	                {
			$this->get_tags_main=$this->model->get_tags_code($offset,10,$key);
			$this->total=$this->model->get_tags_code_count($key);
			}
			elseif($mod=="users")
	                {
			$this->get_tags_main=$this->model->get_tags_user($offset,10,$this->userid, $key);
			$this->total=$this->model->get_tags_user_count($this->userid,$key);
			}
			elseif($mod=="answers")
	                {
			$this->get_tags_main=$this->model->get_tags_ans($offset,10, $key);
			$this->total=$this->model->get_tags_ans_count($key);
			}
			
			$this->template->pagination = new Pagination(array
			(
			 'base_url'       => 'tags/',
			 'uri_segment'    => ''.$mod.'/'.$key.'',
			 'items_per_page' => 10,
			 'total_items'    => $this->total,
			 'style'         => 'classic' )
			 );

			$this->template->title = "Tags";

			// template code
			
			$this->template->content = new View("tags/tags_main");
			
			$this->title_content = "Tags";
		}


	}
?>
