<?php

/**
 * Defines the database activity for answers module
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

class Tags_Model extends Model
{

	public function __construct()
	{
		parent::__construct();
		$db=new Database();
		$this->update=new update_model_Model();
		include Kohana::find_file('../application/config','database',TRUE,'php');
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		$this->uidfield = $config['uidfield'];
		$this->unamefield = $config['unamefield'];
                $this->upass = $config['upass'];
                $this->uemail = $config['uemail'];
                $this->ustatus = $config['ustatus'];
                $this->utype = $config['utype'];
		$mes=Kohana::config('users_config.session_message');
		$this->post_question=$mes["post_question"];
		$this->question_exist=$mes["question_exist"];
		$this->post_answer=$mes["post_answer"];
		$this->not_answered=$mes["not_answered"];
		
		$this->session = Session::instance();
		$this->user_id=$this->session->get('userid');
		$$this->docroot =  Kohana::config('database.server_path');

	}
	public function get_tags()
	{
		$result = $this->db->query("select * from ".$this->prefix."tags WHERE tag_date BETWEEN DATE_SUB(CURDATE(), INTERVAL 20 DAY) AND CURDATE() order by tag_count limit 0,20");
		return $result;
	
	}	   
		
	public function get_tags_ans($offset,$noofpage,$key)
	{
		$result=$this->db->query("select *,".$this->usertable.".".$this->unamefield." as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->usertable." on ".$this->prefix."question.user_id=".$this->usertable.".".$this->uidfield." left join ".$this->prefix."users_profile on ".$this->usertable.".".$this->uidfield."=".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where tags like '%$key%' AND ".$this->prefix."question.status=0 limit $offset,$noofpage");
		return $result;
	
	}
	public function get_tags_ans_count($key)
	{
		$result=$this->db->query("select ".$this->prefix."question.id as question_id from ".$this->prefix."question where tags like '%$key%'  AND ".$this->prefix."question.status=0 ");
		
		return count($result);
	
	}
	public function get_tags_user($offset = "", $noofpage = "", $userid = "", $search = "")
	{
	      $query = "select ".$this->uidfield." as id,".$this->unamefield." as name,last_name,skills as tags,user_photo,".$this->prefix."country.cdesc as cdesc,city,gender,street,".$this->usertable.".".$this->uidfield." as uid from ".$this->usertable." left join ".$this->prefix."users_profile on ".$this->usertable.".".$this->uidfield."=".$this->prefix."users_profile.user_id left join ".$this->prefix."country on ".$this->prefix."users_profile.country = ".$this->prefix."country.cid where ".$this->usertable.".".$this->uidfield." != '$userid' and ".$this->usertable.".".$this->ustatus."=1 and skills like '%$search%' limit $offset,$noofpage";
		$result = $this->db->query($query); 
		return $result;
	
	}
	public function get_tags_user_count($userid = "", $search = "")
	{
		$query = "select ".$this->uidfield." as id,".$this->unamefield." as name,last_name,user_photo,".$this->prefix."country.cdesc as cdesc,city,gender,street,".$this->usertable.".".$this->uidfield." as uid from ".$this->usertable." left join ".$this->prefix."users_profile on ".$this->usertable.".".$this->uidfield."=".$this->prefix."users_profile.user_id left join ".$this->prefix."country on ".$this->prefix."users_profile.country = ".$this->prefix."country.cid where ".$this->usertable.".".$this->uidfield." != '$userid' and ".$this->usertable.".".$this->ustatus."=1 and skills like '%$search%' ";
		$result = $this->db->query($query); 
		return count($result);
	
	}
	public function get_tags_code($offset,$noofpage,$key)
	{
	$type='0';
	        $result= $this->db->query("select *,cdate as DATE,".$this->usertable.".".$this->unamefield." as name ,".$this->prefix."codes.uid as uid,".$this->prefix."codes.category_id as category_id from ".$this->prefix."codes LEFT JOIN ".$this->usertable." ON ".$this->prefix."codes.uid=".$this->usertable.".".$this->uidfield." left join ".$this->prefix."users_profile on ".$this->usertable.".".$this->uidfield."=".$this->prefix."users_profile.user_id left join ".$this->prefix."codes_category on ".$this->prefix."codes.category_id=".$this->prefix."codes_category.category_id having ".$this->prefix."codes.tags like '%$key%' and ".$this->prefix."codes.status='$type' and block = '1' order by ".$this->prefix."codes.codes_id desc limit $offset,$noofpage");
		return $result;
	}
	
	public function get_tags_code_count($key)
	{
	$type='0';
		 $result =$this->db->query("select *,cdate as DATE,".$this->usertable.".".$this->unamefield." as name ,".$this->prefix."codes.uid as uid,".$this->prefix."codes.category_id as category_id from ".$this->prefix."codes LEFT JOIN ".$this->usertable." ON ".$this->prefix."codes.uid=".$this->usertable.".".$this->uidfield." left join ".$this->prefix."users_profile on ".$this->usertable.".".$this->uidfield."=".$this->prefix."users_profile.user_id left join ".$this->prefix."codes_category on ".$this->prefix."codes.category_id=".$this->prefix."codes_category.category_id having ".$this->prefix."codes.tags like '%$key%' and ".$this->prefix."codes.status='$type' and block = '1' order by ".$this->prefix."codes.codes_id desc");
		return count($result);
	
	}
	
}
?>
