<?php defined('SYSPATH') OR die('No direct access allowed.'); 

    $project_title = $this->general_setting_info["title"];
    $meta_keywords = $this->general_setting_info["meta_keywords"];
    $meta_desc = $this->general_setting_info["meta_desc"];
    $logo_path = $this->general_setting_info["logo_path"];
    

    $generate_meta_key = $project_title.',';
    if($this->template->title)
    {
        $key_val = explode(' ',$this->template->title);
        foreach($key_val as $m_key)
        {
               if(strlen($m_key)>4) 
               {
                  $generate_meta_key .= $m_key.",";
               }
        }
    }
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta name="description" content="<?php echo $project_title.' '.$meta_desc.'.'.$this->template->title.'.';?>" />
<meta name="keywords" content="<?php echo $generate_meta_key.' '.$meta_keywords;?>" />
<link rel="shortcut icon" href="<?php echo $this->docroot;?>public/images/favicon.jpg" type="image/x-icon" />
<link href="<?php echo $this->docroot;?>public/css/datepicker.css" rel="stylesheet" type="text/css" />
<title>
<?php if($title!='') { echo $project_title." - ".html::specialchars($title); } else { echo $project_title;} ?>
</title>
<link href="<?php echo $this->docroot;?>public/css/layout/screen.css" rel="stylesheet" type="text/css" />
<link href="<?php echo $this->docroot;?>public/css/jquery_validation_include_css.css" rel="stylesheet" type="text/css" />
<link href="<?php echo $this->docroot;?>public/themes/<?php echo $this->get_theme;?>/css/style.css" rel="stylesheet" type="text/css" />
<link href="<?php echo $this->docroot;?>public/themes/<?php echo $this->get_theme;?>/css/jquery.alerts.css" rel="stylesheet" type="text/css" />

<script src="<?php echo $this->docroot;?>public/js/jquery.js" type="text/javascript"></script>
<script src="<?php echo $this->docroot;?>public/js/jquery.validate.js" type="text/javascript"></script>
<script src="<?php echo $this->docroot;?>public/js/login_validation.js" type="text/javascript"></script>
<script src="<?php echo $this->docroot;?>public/js/validation.js" type="text/javascript"></script>
<script src="<?php echo $this->docroot;?>public/js/jquery.alerts.js" type="text/javascript"></script>

</head>
<body >
<?php require_once("$this->get_theme/header.php");?>

 <script type="text/javascript">
                   $(document).ready(function () {
		                if($('#messagedisplay')){
		                  $('#messagedisplay').animate({opacity: 1.0}, 5000)
		                  $('#messagedisplay').fadeOut('slow');
		                }
		                //error message
		                if($('#error_messagedisplay')){
			                $('#error_messagedisplay').animate({opacity: 1.0}, 5000)
			                $('#error_messagedisplay').fadeOut('slow');
		                }
		                });
	                </script>
	                
                 

                        <?php   
		                //show the response message     
	                  if(!empty($this->response))
	                  { ?>
                                  <div id="messagedisplay" >
                                    <center>
                                      <div  class="success p5">
                                          <?php echo $this->response; ?>
                                      </div>
                                    </center>
                                  </div>
                        <?php } ?>
                        <?php 
	                  if(!empty($this->error_response))
	                  { ?>
                                  <div id="error_messagedisplay" >
                                 <center>
                                    <div  class="error p5"  >
                                        <?php echo $this->error_response; ?>
                                    </div>
                                  </center>
                                  </div>
                        <?php 
	                  }
	                ?> 
	                
<div class="container_outer box_outerdiv" >
        
        <div class="container_middle box_innerrdiv">
                  <div class="container">
                  <?php echo $content ?>                   
                  </div>
          </div>
  </div>
   </div>
<?php require_once("$this->get_theme/footer.php");?>


</body>
</html>
